package com.steerinfo.baseinfo.meterbasecustomersupplier.controller;

import com.steerinfo.baseinfo.dto.MeterBaseCustomerSupplierDto;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbasecustomersupplier.model.MeterBaseCustomerSupplier;
import com.steerinfo.baseinfo.meterbasecustomersupplier.service.IMeterBaseCustomerSupplierService;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.util.StringUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseCustomerSupplier RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-06-15 11:14
 * 类描述
 * 修订历史：
 * 日期：2020-06-15
 * 作者：generator
 * 参考：
 * 描述：MeterBaseCustomerSupplier RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterbasecustomersuppliers")
@Api(value = "/${api.version}/meterbasecustomersuppliers", tags = "客商维护 - MeterBaseCustomerSupplierController")
public class MeterBaseCustomerSupplierController extends BaseRESTfulController {

    @Autowired
    IMeterBaseCustomerSupplierService meterBaseCustomerSupplierService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasecustomersupplier:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseCustomerSupplier> list = meterBaseCustomerSupplierService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "不分页查询")
    @GetMapping(value = "/noPage")
    public RESTfulResult listall(@RequestParam HashMap parmas) {
        try {
            List<MeterBaseCustomerSupplier> list = meterBaseCustomerSupplierService.queryAll(parmas);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasecustomersupplier:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseCustomerSupplier> list = meterBaseCustomerSupplierService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterBaseCustomerSupplier对象创建")
    @ApiImplicitParam(name = "meterBaseCustomerSupplier", value = "详细实体meterBaseCustomerSupplier", required = true, dataType = "MeterBaseCustomerSupplier")
    //@RequiresPermissions("meterbasecustomersupplier:create")
    @Transactional
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterBaseCustomerSupplier model) {
        try {
            String msg = meterBaseCustomerSupplierService.checkandadd(model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }

        return success();
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasecustomersupplier:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterBaseCustomerSupplier meterBaseCustomerSupplier = meterBaseCustomerSupplierService.getById(id);
            return success(meterBaseCustomerSupplier);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterBaseCustomerSupplier信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterBaseCustomerSupplier", value = "详细实体meterBaseCustomerSupplier", required = true, dataType = "MeterBaseCustomerSupplier")
    })
    @Transactional
    //@RequiresPermissions("meterbasecustomersupplier:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseCustomerSupplier model) {
        try {
            String msg = meterBaseCustomerSupplierService.checkandupdate(id, model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }

        return success();
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasecustomersupplier:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterBaseCustomerSupplierService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "启用标识符", notes = "根据传过来的MeterBaseCustomerSupplier集合信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "MeterBaseCustomerSupplier", value = "详细实体MeterBaseCustomerSupplier", required = true, dataType = "MeterBaseCustomerSupplier")
    })
    @Transactional
    @PostMapping(value = "/Recovery")
    public RESTfulResult Recovery(@RequestBody List<MeterBaseCustomerSupplier> models) {
        try {
            String msg = meterBaseCustomerSupplierService.Recovery(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }


    @ApiOperation(value = "废除标识符", notes = "根据传过来的MeterBaseCustomerSupplier集合信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "MeterBaseCustomerSupplier", value = "详细实体MeterBaseCustomerSupplier", required = true, dataType = "MeterBaseCustomerSupplier")
    })
    @Transactional
    @PostMapping(value = "/abolish")
    public RESTfulResult abolish(@RequestBody List<MeterBaseCustomerSupplier> models) {
        try {
            String msg = meterBaseCustomerSupplierService.abolish(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "获取一次计量数据页面的收货单位", notes = "根据参数进行查询")
    @GetMapping(value = "/selectIn")
    public RESTfulResult selectIn() {
        RESTfulResult rm = failed();
        try {
            List<MeterBaseCustomerSupplierDto> rows = meterBaseCustomerSupplierService.selectIn();
            if (rows == null || rows.size() <= 0) {
                return failed("无收货单位信息！！");
            }
            return success(rows);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "获取一次计量数据页面的发货单位", notes = "根据参数进行查询")
    @GetMapping(value = "/selectOut")
    public RESTfulResult selectOut() {
        RESTfulResult rm = failed();
        try {
            List<MeterBaseCustomerSupplierDto> rows = meterBaseCustomerSupplierService.selectOut();
            if (rows == null || rows.size() <= 0) {
                return failed("无发货单位信息！！");
            }
            return success(rows);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }


    @ApiOperation(value = "审核", notes = "根据传过来的MeterBaseCustomerSupplier集合信息来审核")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "MeterBaseCustomerSupplier", value = "详细实体MeterBaseCustomerSupplier", required = true, dataType = "MeterBaseCustomerSupplier")
    })
    @Transactional
    @PostMapping(value = "/audit")
    public RESTfulResult audit(@RequestBody List<MeterBaseCustomerSupplier> models) {
        try {
            String msg = meterBaseCustomerSupplierService.audit(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "反审", notes = "根据传过来的MeterBaseCustomerSupplier集合信息来反审")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "MeterBaseCustomerSupplier", value = "详细实体MeterBaseCustomerSupplier", required = true, dataType = "MeterBaseCustomerSupplier")
    })
    @Transactional
    @PostMapping(value = "/unaudit")
    public RESTfulResult unaudit(@RequestBody List<MeterBaseCustomerSupplier> models) {
        try {
            String msg = meterBaseCustomerSupplierService.unaudit(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "获取非货代信息", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasecustomersupplier:view")
    @GetMapping(value = "/selectByType")
    public RESTfulResult selectByType(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseCustomerSupplier> list = meterBaseCustomerSupplierService.selectByType(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取打印特定的发货单位", notes = "根据参数进行查询")
    @GetMapping(value = "/selectPrint/")
    public RESTfulResult selectPrint() {
        RESTfulResult rm = failed();
        try {
            List<MeterBaseCustomerSupplier> rows = meterBaseCustomerSupplierService.selectPrint();
            if (rows == null || rows.size() <= 0) {
                return failed("无发货单位信息！！");
            }
            return success(rows);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {
        }
        return rm;
    }

}

